## ros-foxy-maliput-drake 0.1.2

=== CMakeLists.txt ===
##############################################################################
# Project
##############################################################################

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(maliput_drake LANGUAGES C CXX VERSION 0.1.0)

##############################################################################
# Find 3rd Party Packages
##############################################################################

message(STATUS "\n\n====== Finding 3rd Party Packages ======\n")

find_package(ament_cmake REQUIRED)

find_package(eigen3_cmake_module REQUIRED)
find_package(Eigen3)
find_package(fmt 6.1.2 EXACT REQUIRED)

##############################################################################
# Project Configuration
##############################################################################

message(STATUS "\n\n========= Project Configuration ========\n")

set(BUILD_SHARED_LIBS true)

include(${PROJECT_SOURCE_DIR}/cmake/DefaultCFlags.cmake)
include(${PROJECT_SOURCE_DIR}/cmake/SanitizersConfig.cmake)

ament_environment_hooks(
  "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
)

##############################################################################
# Sources
##############################################################################
add_subdirectory(src)

##############################################################################
# Export
##############################################################################

install(
  DIRECTORY include/
  DESTINATION include
)

ament_export_include_directories(include)

ament_environment_hooks(setup.sh.in)
ament_export_dependencies(ament_cmake)
ament_export_dependencies(fmt)
ament_export_dependencies(eigen3_cmake_module)
ament_export_dependencies(Eigen3)
ament_export_targets(${PROJECT_NAME}-targets HAS_LIBRARY_TARGET)
ament_package()

=== src/CMakeLists.txt ===
add_subdirectory(common)
add_subdirectory(math)
add_subdirectory(systems)

=== src/common/CMakeLists.txt ===
add_library(common
  cond.cc
  double_overloads.cc
  drake_assert_and_throw.cc
  drake_marker.cc
  hash.cc
  nice_type_name.cc
  nice_type_name_override.cc
  pointer_cast.cc
  polynomial.cc
  random.cc
  sorted_pair.cc
  symbolic.cc
  symbolic_chebyshev_basis_element.cc
  symbolic_chebyshev_polynomial.cc
  symbolic_codegen.cc
  symbolic_decompose.cc
  symbolic_environment.cc
  symbolic_expression.cc
  symbolic_expression_cell.cc
  symbolic_formula.cc
  symbolic_formula_cell.cc
  symbolic_generic_polynomial.cc
  symbolic_ldlt.cc
  symbolic_monomial_basis_element.cc
  symbolic_monomial.cc
  symbolic_monomial_util.cc
  symbolic_polynomial_basis_element.cc
  symbolic_polynomial.cc
  symbolic_rational_function.cc
  symbolic_simplification.cc
  symbolic_variable.cc
  symbolic_variables.cc
  text_logging.cc
  value.cc
)

add_library(maliput_drake::common ALIAS common)

set_target_properties(
  common
  PROPERTIES
    OUTPUT_NAME ${PROJECT_NAME}_common
)

target_include_directories(
  common
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

target_link_libraries(
  common
    dl
    Eigen3::Eigen
    fmt::fmt
)

install(
  TARGETS common
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

add_subdirectory(trajectories)

=== src/math/CMakeLists.txt ===
add_library(math
  autodiff.cc
  autodiff_gradient.cc
  barycentric.cc
  bspline_basis.cc
  continuous_algebraic_riccati_equation.cc
  continuous_lyapunov_equation.cc
  cross_product.cc
  discrete_algebraic_riccati_equation.cc
  discrete_lyapunov_equation.cc
  eigen_sparse_triplet.cc
  evenly_distributed_pts_on_sphere.cc
  fast_pose_composition_functions.cc
  gradient.cc
  gray_code.cc
  hopf_coordinate.cc
  jacobian.cc
  matrix_util.cc
  normalize_vector.cc
  orthonormal_basis.cc
  quadratic_form.cc
  quaternion.cc
  random_rotation.cc
  rigid_transform.cc
  roll_pitch_yaw.cc
  rotation_conversion_gradient.cc
  rotation_matrix.cc
)

add_library(maliput_drake::math ALIAS math)

set_target_properties(
  math
  PROPERTIES
    OUTPUT_NAME ${PROJECT_NAME}_math
)

target_include_directories(
  math
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

target_link_libraries(
  math
    Eigen3::Eigen
    fmt::fmt
    maliput_drake::common
)

install(
  TARGETS math
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== src/systems/CMakeLists.txt ===
add_subdirectory(analysis)
add_subdirectory(framework)

=== src/common/trajectories/CMakeLists.txt ===
add_library(trajectories
  bspline_trajectory.cc
  discrete_time_trajectory.cc
  exponential_plus_piecewise_polynomial.cc
  piecewise_polynomial.cc
  piecewise_pose.cc
  piecewise_quaternion.cc
  piecewise_trajectory.cc
  trajectory.cc
)

add_library(maliput_drake::trajectories ALIAS trajectories)

set_target_properties(
  trajectories
  PROPERTIES
    OUTPUT_NAME ${PROJECT_NAME}_trajectories
)

target_include_directories(
  trajectories
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

target_link_libraries(
  trajectories
    Eigen3::Eigen
    fmt::fmt
    maliput_drake::common
    maliput_drake::math
)

install(
  TARGETS trajectories
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== src/systems/analysis/CMakeLists.txt ===
add_library(analysis
  antiderivative_function.cc
  dense_output.cc
  hermitian_dense_output.cc
  initial_value_problem.cc
  integrator_base.cc
  runge_kutta3_integrator.cc
  scalar_dense_output.cc
  scalar_initial_value_problem.cc
  scalar_view_dense_output.cc
  stepwise_dense_output.cc
)

add_library(maliput_drake::analysis ALIAS analysis)

set_target_properties(
  analysis
  PROPERTIES
    OUTPUT_NAME ${PROJECT_NAME}_analysis
)

target_include_directories(
  analysis
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

target_link_libraries(
  analysis
    Eigen3::Eigen
    fmt::fmt
    maliput_drake::common
    maliput_drake::math
    maliput_drake::framework
)

install(
  TARGETS analysis
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== src/systems/framework/CMakeLists.txt ===
add_library(framework
  abstract_value_cloner.cc
  abstract_values.cc
  basic_vector.cc
  cache.cc
  cache_entry.cc
  context_base.cc
  context.cc
  continuous_state.cc
  dependency_tracker.cc
  diagram_builder.cc
  diagram.cc
  diagram_context.cc
  diagram_continuous_state.cc
  diagram_discrete_values.cc
  diagram_output_port.cc
  diagram_state.cc
  discrete_values.cc
  event_collection.cc
  fixed_input_port_value.cc
  input_port_base.cc
  input_port.cc
  leaf_context.cc
  leaf_output_port.cc
  leaf_system.cc
  model_values.cc
  output_port_base.cc
  output_port.cc
  parameters.cc
  port_base.cc
  scalar_conversion_traits.cc
  single_output_vector_source.cc
  state.cc
  subvector.cc
  supervector.cc
  system_base.cc
  system.cc
  system_constraint.cc
  system_html.cc
  system_output.cc
  system_scalar_converter.cc
  system_symbolic_inspector.cc
  system_type_tag.cc
  system_visitor.cc
  value_producer.cc
  vector_base.cc
  vector_system.cc
  witness_function.cc
)

add_library(maliput_drake::framework ALIAS framework)

set_target_properties(
  framework
  PROPERTIES
    OUTPUT_NAME ${PROJECT_NAME}_framework
)

target_include_directories(
  framework
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

target_link_libraries(
  framework
    fmt::fmt
    Eigen3::Eigen
    maliput_drake::common
    maliput_drake::math
)

install(
  TARGETS framework
  EXPORT ${PROJECT_NAME}-targets
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== debian/changelog ===
ros-foxy-maliput-drake (0.1.2-1focal) focal; urgency=high

  * Improves README. (#25 <https://github.com/maliput/maliput_drake/issues/25>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Thu, 13 Apr 2023 03:00:00 -0000

ros-foxy-maliput-drake (0.1.1-1focal) focal; urgency=high

  * Fixes include folder installation. (#23 <https://github.com/maliput/maliput_drake/issues/23>)
  * Contributors: Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Mon, 13 Jun 2022 03:00:00 -0000

ros-foxy-maliput-drake (0.1.0-1focal) focal; urgency=high

  * Moves package to root. (#22 <https://github.com/maliput/maliput_drake/issues/22>)
  * Updates license. (#21 <https://github.com/maliput/maliput_drake/issues/21>)
  * Uses ament_export_targets. (#20 <https://github.com/maliput/maliput_drake/issues/20>)
  * Removes dashing support. (#19 <https://github.com/maliput/maliput_drake/issues/19>)
  * Adds CI badges (#18 <https://github.com/maliput/maliput_drake/issues/18>)
  * Removes spdlog dependency. (#17 <https://github.com/maliput/maliput_drake/issues/17>)
  * Replaces push by workflow_dispatch event in gcc build. (#15 <https://github.com/maliput/maliput_drake/issues/15>)
  * Adds to the supression list maliput_drake's header files. (#13 <https://github.com/maliput/maliput_drake/issues/13>)
  * Remove autodiff and symbolic instantiations (#11 <https://github.com/maliput/maliput_drake/issues/11>)
  * Remove gflags dependency (#10 <https://github.com/maliput/maliput_drake/issues/10>)
  * Reduce dependencies of analysis (#9 <https://github.com/maliput/maliput_drake/issues/9>)
  * Renames drake definitions (#8 <https://github.com/maliput/maliput_drake/issues/8>)
  * Removes unused extern C method. (#7 <https://github.com/maliput/maliput_drake/issues/7>)
  * Instructions to copy a drake release (#5 <https://github.com/maliput/maliput_drake/issues/5>)
  * Namespace with maliput (#4 <https://github.com/maliput/maliput_drake/issues/4>)
  * Create a proper readme (#3 <https://github.com/maliput/maliput_drake/issues/3>)
  * Adds bionic support (#2 <https://github.com/maliput/maliput_drake/issues/2>)
  * Initial repository structure (#1 <https://github.com/maliput/maliput_drake/issues/1>)
  * Contributors: Agustin Alba Chicar, Franco Cipollone

 -- Daniel Stonier <daniel.stonier@tri.global>  Fri, 10 Jun 2022 03:00:00 -0000

=== debian/control ===
Source: ros-foxy-maliput-drake
Section: misc
Priority: optional
Maintainer: Daniel Stonier <daniel.stonier@tri.global>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libfmt-dev, ros-foxy-ament-cmake, ros-foxy-eigen3-cmake-module, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-maliput-drake
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libfmt-dev, ros-foxy-eigen3-cmake-module, ros-foxy-ros-workspace
Description: Maliput drake extraction to provide trajectory integration support

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-maliput-drake//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
